
// WsimView.cpp : CWsimView NX̎
//

#include "stdafx.h"
// SHARED_HANDLERS ́Avr[AkŁAьtB^[ nh[Ă ATL vWFNgŒ`łA
// ̃vWFNgƂ̃hLg R[h̋L\ɂ܂B
#ifndef SHARED_HANDLERS
#include "Wsim.h"
#endif

#include "WsimDoc.h"
#include "WsimView.h"

#include "DrawDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma comment(lib, "winmm.lib")

// CWsimView

IMPLEMENT_DYNCREATE(CWsimView, CEditView)

BEGIN_MESSAGE_MAP(CWsimView, CEditView)
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, &CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CEditView::OnFilePrintPreview)
	ON_COMMAND(ID_RUN, &CWsimView::OnRun)
	ON_MESSAGE(MM_WOM_DONE, &CWsimView::OnPlayData)
	ON_COMMAND(ID_STOP, &CWsimView::OnPlayStop)
	ON_COMMAND(ID_GRAPH, &CWsimView::OnGraph)
	ON_WM_PAINT()
	ON_COMMAND(ID_SETUP, &CWsimView::OnSetup)
	ON_COMMAND(ID_FREQ, &CWsimView::OnFreq)
END_MESSAGE_MAP()

// CWsimView RXgNV/fXgNV

CWsimView::CWsimView()
{
	// TODO: \zR[hɒǉ܂B

	wave_on = 0;
	input_wave = 0;

	x_10 = 0;
	x_11 = 0;
	x_12 = 0;
	x_13 = 0;
	x_21 = 0;
	x_22 = 0;
	x_23 = 0;
	al = 0;
	wave_freq = 1000;
	//  freq_mode = 0;
	freq_mode = 0;
	draw_text = 0;
}

CWsimView::~CWsimView()
{
}

BOOL CWsimView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// [h bvgp\ɂ܂

	return bPreCreated;
}


// CWsimView 

BOOL CWsimView::OnPreparePrinting(CPrintInfo* pInfo)
{
	//  CEditView ̈
	return CEditView::OnPreparePrinting(pInfo);
}

void CWsimView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	//  CEditView ňJn܂B
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CWsimView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	//  CEditView ̈̌㏈
	CEditView::OnEndPrinting(pDC, pInfo);
}


// CWsimView ff

#ifdef _DEBUG
void CWsimView::AssertValid() const
{
	CEditView::AssertValid();
}

void CWsimView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CWsimDoc* CWsimView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWsimDoc)));
	return (CWsimDoc*)m_pDocument;
}
#endif //_DEBUG


// CWsimView bZ[W nh[


void CWsimView::OnRun()
{
	// TODO: ɃR}h nh[ R[hǉ܂B

	int  i;

	if (wave_on) return;
	wave_on = 1;

	wf.wFormatTag = WAVE_FORMAT_PCM;
	wf.nChannels = 1;
	wf.nSamplesPerSec = FREQUENCY;
	wf.nAvgBytesPerSec = FREQUENCY * 2;
	wf.nBlockAlign = 2;
	wf.wBitsPerSample = 16;
	wf.cbSize = 0;

	for (i = 0; i < BLOCK_NUMS; i++)
	{
		memset(bufOut[i], '\0', ONE_BLOCK_DATA_NUM * 2);
		whOut[i].lpData = (char *)bufOut[i];
		whOut[i].dwBufferLength = ONE_BLOCK_DATA_NUM * 2;
		whOut[i].dwBytesRecorded = 0;
		whOut[i].dwUser = 0;
		whOut[i].dwFlags = 0;
		whOut[i].dwLoops = 1;
		whOut[i].lpNext = NULL;
		whOut[i].reserved = 0;
	}
	
	MMRESULT mmrError = waveOutOpen(&hWOut, WAVE_MAPPER, &wf, (DWORD)m_hWnd, 0, CALLBACK_WINDOW);
	for (i = 0; i < BLOCK_NUMS; i++)
	{
		memset(bufOut[i], '\0', ONE_BLOCK_DATA_NUM * 2);
		PreparePlayData(i);
		whOut[i].dwFlags = 0;
		waveOutPrepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
		waveOutWrite(hWOut, &whOut[i], sizeof(WAVEHDR));
	}
	
}


afx_msg LRESULT CWsimView::OnPlayData(WPARAM wParam, LPARAM lParam)
{
	for (int i = 0; i < BLOCK_NUMS; i++)
	{
		if ((whOut[i].dwFlags & WHDR_DONE) == WHDR_DONE)
		{
			PreparePlayData(i);
			waveOutUnprepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
			waveOutPrepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
			waveOutWrite(hWOut, &whOut[i], sizeof(WAVEHDR));
			break;
		}
	}
	return 0;
}


void CWsimView::PreparePlayData(int nBlock)
{
	// 6Butterworth LPF
	//  : (s^2 + 0.51764s + 1)(s^2 + 1.41421s + 1)(s^2 + 1.93185s + 1)

	double  flpf = 1000;   // LPF : cutoff=1KHz
	double  tt = 8.0 * atan(1.0) * flpf / FREQUENCY;
	double  a1 = 0.51764;
	double  a2 = 1.41421;
	double  a3 = 1.93185;
	double  a4 = 1 / flpf; // HPF : cutoff=1Hz
	double  k1 = sqrt(1 - a1*a1 / 4);
	double  k2 = sqrt(1 - a2*a2 / 4);
	double  k3 = sqrt(1 - a3*a3 / 4);

	double  ux1 = a1*(1 - exp(-a1*tt / 2)*cos(k1*tt)) + (1 - a1*a1 / 2)*exp(-a1*tt / 2)*sin(k1*tt) / k1;
	double  ux2 = 1 - exp(-a1*tt / 2)*(cos(k1*tt) + a1*sin(k1*tt) / (2 * k1));
	double  ux3 = a2*(1 - exp(-a2*tt / 2)*cos(k2*tt)) + (1 - a2*a2 / 2)*exp(-a2*tt / 2)*sin(k2*tt) / k2;
	double  ux4 = 1 - exp(-a2*tt / 2)*(cos(k2*tt) + a2*sin(k2*tt) / (2 * k2));
	double  ux5 = a3*(1 - exp(-a3*tt / 2)*cos(k3*tt)) + (1 - a3*a3 / 2)*exp(-a3*tt / 2)*sin(k3*tt) / k3;
	double  ux6 = 1 - exp(-a3*tt / 2)*(cos(k3*tt) + a3*sin(k3*tt) / (2 * k3));

	double  x10, x20, u, y;
	double  pif = 8.0 * atan(1.0) * wave_freq;

	for (int i = 0; i < ONE_BLOCK_DATA_NUM; i++)
	{
		if (!input_wave)
		    u = 10000 * sin(al); // sin
		else
			u = 10000;
		/*
		if (freq_mode)
		{
			if (i)
				u = 0;
			else
				u = 10000;
		}
		*/
		x10 = exp(-a1*tt / 2)*(x_11*cos(k1*tt) + (a1*x_11 / 2 - x_21)*sin(k1*tt) / k1) + ux1*u;
		x20 = exp(-a1*tt / 2)*(x_21*cos(k1*tt) - (a1*x_21 / 2 - x_11)*sin(k1*tt) / k1) + ux2*u;
		x_11 = x10;
		x_21 = x20;
		x10 = exp(-a2*tt / 2)*(x_12*cos(k2*tt) + (a2*x_12 / 2 - x_22)*sin(k2*tt) / k2) + ux3*x20;
		x20 = exp(-a2*tt / 2)*(x_22*cos(k2*tt) - (a2*x_22 / 2 - x_12)*sin(k2*tt) / k2) + ux4*x20;
		x_12 = x10;
		x_22 = x20;
		x10 = exp(-a3*tt / 2)*(x_13*cos(k3*tt) + (a3*x_13 / 2 - x_23)*sin(k3*tt) / k3) + ux5*x20;
		x20 = exp(-a3*tt / 2)*(x_23*cos(k3*tt) - (a3*x_23 / 2 - x_13)*sin(k3*tt) / k3) + ux6*x20;
		x_13 = x10;
		x_23 = x20;
		x10 = exp(-a4*tt)*x_10 + (1 - exp(-a4*tt))*x20;
		x_10 = x10;
		y = -exp(-a4*tt)*x_10 + exp(-a4*tt)*x20;

		bufOut[nBlock][i] = (short)y;
		al += pif / FREQUENCY;
	}
}


void CWsimView::OnPlayStop()
{
	waveOutReset(hWOut);
	for (int i = 0; i < BLOCK_NUMS; i++)
	{
		waveOutUnprepareHeader(hWOut, &whOut[i], sizeof(WAVEHDR));
	}
	waveOutClose(hWOut);

	wave_on = 0;
}


void CWsimView::OnGraph()
{
	// range x : 0-3  y : 0-20

	double x, y, x0, y0;
	char draw;
	CRect  rect;
	CClientDC  dc(this);
	int   i;

	GetClientRect(rect);
	if (rect.Width()<200) draw = 0;
	else  draw = 1;

	dc.FillSolidRect(&rect, RGB(255, 255, 255));
	m_pointArray.RemoveAll();

	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(760, 640);
	dc.SetViewportExt(rect.Width(), rect.Height()); // (int)(640 * rect.Width() / 760));

	CPen R_Pen(PS_SOLID, 1, RGB(255, 0, 0));
	CPen B_Pen(PS_SOLID, 1, RGB(0, 0, 255));
	CPen* pOldPen;

	pOldPen = dc.SelectObject(&B_Pen);

	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20, 20 + i * 30);
		dc.LineTo(740, 20 + i * 30);
	}
	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20 + 720 * i / 20, 20);
		dc.LineTo(20 + 720 * i / 20, 620);
	}

	dc.SelectStockObject(NULL_BRUSH);

	dc.MoveTo(20, 320);
	dc.LineTo(740, 320);

	pOldPen = dc.SelectObject(&R_Pen);

	dc.MoveTo(20, 320);
	dc.LineTo(740, 320);

	if (!freq_mode)
		PreparePlayData(0);

	if (draw)
	{
		for (i = 0; i < ONE_BLOCK_DATA_NUM; i++)
		{
			y = bufOut[0][i];
			if (!freq_mode)
			{
				x = (double)i * 3 / ONE_BLOCK_DATA_NUM;
				y = 10 * (1 - y*0.00005);  // Wϊ
			}
			else
			{
				x = (double)i * 6 / ONE_BLOCK_DATA_NUM;
				y = 10 * (1 - y*0.01); // 10dB/div, max 20KHz
				if (i > 1000)
					break;
			}
			if (i != 0)
				draw_line(x0, y0, x, y);
			x0 = x;
			y0 = y;
		}
	}

	dc.SelectObject(pOldPen);
}


void CWsimView::draw_line(double x1, double y1, double x2, double y2)
{
	// range x : 0-3  y : 0-20

	double x, y;
	CClientDC  dc(this);
	CRect  rect;

	GetClientRect(rect);

	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(760, 640);
	dc.SetViewportExt(rect.Width(), rect.Height()); // (int)(640 * rect.Width() / 760));

	CPen R_Pen(PS_SOLID, 1, RGB(255, 0, 0));
	CPen* pOldPen;

	dc.SelectStockObject(NULL_BRUSH);

	pOldPen = dc.SelectObject(&R_Pen);

	x = x1;
	y = y1;
	dc.MoveTo((int)(20 + 240 * x), (int)(20 + 30 * y));
	m_pointArray.Add(CPoint((int)(20 + 240 * x), (int)(20 + 30 * y)));
	x = x2;
	y = y2;
	dc.LineTo((int)(20 + 240 * x), (int)(20 + 30 * y));
	m_pointArray.Add(CPoint((int)(20 + 240 * x), (int)(20 + 30 * y)));

	dc.SelectObject(pOldPen);
}


void CWsimView::OnPaint()
{
	CPaintDC dc(this);
	CRect  rect;
	int    i;

	GetClientRect(rect);
	if (rect.Width()<200) return;

	dc.SetMapMode(MM_ANISOTROPIC);
	dc.SetWindowExt(760, 640);
	dc.SetViewportExt(rect.Width(), rect.Height()); // (int)(640 * rect.Width() / 760));

	CPen R_Pen(PS_SOLID, 1, RGB(255, 0, 0));
	CPen G_Pen(PS_SOLID, 1, RGB(0, 255, 0));
	CPen B_Pen(PS_SOLID, 1, RGB(0, 0, 255));
	CPen* pOldPen;
	char  s_point;
	
	pOldPen = dc.SelectObject(&B_Pen);

	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20, 20 + i * 30);
		dc.LineTo(740, 20 + i * 30);
	}
	for (i = 0; i<21; i++)
	{
		dc.MoveTo(20 + 720 * i / 20, 20);
		dc.LineTo(20 + 720 * i / 20, 620);
	}
	
	pOldPen = dc.SelectObject(&R_Pen);

	dc.MoveTo(20, 320);
	dc.LineTo(740, 320);

	if (m_pointArray.GetSize())
	{
		s_point = 1;
		for (i = 0; i<m_pointArray.GetSize(); i++)
		{
			if ((m_pointArray[i].x) && (m_pointArray[i].y))
			{
				if (s_point)
				{
					dc.MoveTo(m_pointArray[i]);
					s_point = 0;
				}
				else
					dc.LineTo(m_pointArray[i]);
			}
			else
				s_point = 1;
		}
	}

	dc.SelectObject(pOldPen);
}


void CWsimView::OnSetup()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	
	CDrawDlg  dlg;
	
	dlg.m_radIndex = input_wave;
	dlg.m_nFreq = wave_freq;

	if (dlg.DoModal() == IDOK) {
		input_wave = dlg.m_radIndex;
		wave_freq = dlg.m_nFreq;
		freq_mode = 0;
		draw_text = 0;

		x_10 = 0;
		x_11 = 0;
		x_12 = 0;
		x_13 = 0;
		x_21 = 0;
		x_22 = 0;
		x_23 = 0;
		al   = 0;
	}
}


void CWsimView::OnFreq()
{
	// TODO: ɃR}h nh[ R[hǉ܂B

	// TvO 40960Hz, 2048point -> \ 40960/2048 = 20Hz
	//double  c0[2048];
	//double  c1[2048];

	double  flpf = 1000;   // LPF : cutoff=1KHz
	double  tt = 8.0 * atan(1.0) * flpf / 40960;

	// 6Butterworth LPF
	//  : (s^2 + 0.51764s + 1)(s^2 + 1.41421s + 1)(s^2 + 1.93185s + 1)
	double  a1 = 0.51764;
	double  b1 = 1;
	double  a2 = 1.41421;
	double  b2 = 1;
	double  a3 = 1.93185;
	double  b3 = 1;

	// 6 0.1dB Chebyshev LPF
	//  : (s^2 + 0.22940s + 1.12953)(s^2 + 0.62674s + 0.69646)(s^2 + 0.85614s + 0.26339)
	//double  a1 = 0.22940;
	//double  b1 = 1.12953;
	//double  a2 = 0.62674;
	//double  b2 = 0.69646;
	//double  a3 = 0.85614;
	//double  b3 = 0.26339;

	// 6 0.5dB Chebyshev LPF
	//  : (s^2 + 0.15530s + 1.02302)(s^2 + 0.42429s + 0.59001)(s^2 + 0.57959s + 0.15700)
	//double  a1 = 0.15530;
	//double  b1 = 1.02302;
	//double  a2 = 0.42429;
	//double  b2 = 0.59001;
	//double  a3 = 0.57959;
	//double  b3 = 0.15700;

	// 6 1.0dB Chebyshev LPF
	//  : (s^2 + 0.12436s + 0.99073)(s^2 + 0.33976s + 0.55772)(s^2 + 0.46413s + 0.12471)
	//double  a1 = 0.12436;
	//double  b1 = 0.99073;
	//double  a2 = 0.33976;
	//double  b2 = 0.55772;
	//double  a3 = 0.46413;
	//double  b3 = 0.12471;

	double  a4 = 1 / flpf; // HPF : cutoff=1Hz
	double  k1 = sqrt(b1 - a1*a1 / 4);
	double  k2 = sqrt(b2 - a2*a2 / 4);
	double  k3 = sqrt(b3 - a3*a3 / 4);

	double  ux1 = a1*(1 - exp(-a1*tt / 2)*cos(k1*tt)) + (b1 - a1*a1 / 2)*exp(-a1*tt / 2)*sin(k1*tt) / k1;
	double  ux2 = 1 - exp(-a1*tt / 2)*(cos(k1*tt) + a1*sin(k1*tt) / (2 * k1));
	double  ux3 = a2*(1 - exp(-a2*tt / 2)*cos(k2*tt)) + (b2 - a2*a2 / 2)*exp(-a2*tt / 2)*sin(k2*tt) / k2;
	double  ux4 = 1 - exp(-a2*tt / 2)*(cos(k2*tt) + a2*sin(k2*tt) / (2 * k2));
	double  ux5 = a3*(1 - exp(-a3*tt / 2)*cos(k3*tt)) + (b3 - a3*a3 / 2)*exp(-a3*tt / 2)*sin(k3*tt) / k3;
	double  ux6 = 1 - exp(-a3*tt / 2)*(cos(k3*tt) + a3*sin(k3*tt) / (2 * k3));

	double  x10, x20, u, y;
	double  pif = 8.0 * atan(1.0) * wave_freq;

	int  i;

	CString  str;
	str.Format("1KHz 6th Butterworth LPF + 1Hz HPF \r\nfreq graph : 10dB/div 1KHz/div max 20KHz");
	AfxMessageBox(str, MB_OK, 0);

	freq_mode = 1;

	x_10 = 0;
	x_11 = 0;
	x_12 = 0;
	x_13 = 0;
	x_21 = 0;
	x_22 = 0;
	x_23 = 0;
	al = 0;

	for (i = 0; i < 2048; i++)
	{
		if (i)
		    u = 0;
		else
		    u = 1;

		x10 = exp(-a1*tt / 2)*(x_11*cos(k1*tt) + (a1*x_11 / 2 - b1*x_21)*sin(k1*tt) / k1) + ux1*u;
		x20 = exp(-a1*tt / 2)*(x_21*cos(k1*tt) - (a1*x_21 / 2 - x_11)*sin(k1*tt) / k1) + ux2*u;
		x_11 = x10;
		x_21 = x20;
		x10 = exp(-a2*tt / 2)*(x_12*cos(k2*tt) + (a2*x_12 / 2 - b2*x_22)*sin(k2*tt) / k2) + ux3*x20;
		x20 = exp(-a2*tt / 2)*(x_22*cos(k2*tt) - (a2*x_22 / 2 - x_12)*sin(k2*tt) / k2) + ux4*x20;
		x_12 = x10;
		x_22 = x20;
		x10 = exp(-a3*tt / 2)*(x_13*cos(k3*tt) + (a3*x_13 / 2 - b3*x_23)*sin(k3*tt) / k3) + ux5*x20;
		x20 = exp(-a3*tt / 2)*(x_23*cos(k3*tt) - (a3*x_23 / 2 - x_13)*sin(k3*tt) / k3) + ux6*x20;
		x_13 = x10;
		x_23 = x20;
		x10 = exp(-a4*tt)*x_10 + (1 - exp(-a4*tt))*x20;
		x_10 = x10;
		y = -exp(-a4*tt)*x_10 + exp(-a4*tt)*x20;

		c0[i] = y;
		c1[i] = 0;
		al += pif / 40960;
	}

	fast();
	OnGraph();
}


void CWsimView::fast()
{
	double  x;
	double  t0, t1;
	double  th;
	double  cs, sn;
	double  g;
	int     i, j, k;
	int     ii, jj, kk;
	int     kmax, istep;

	x = 0;
	for (i = 0; i < 2048; i++)
		x = x + c0[i];
	x = x / 2048;
	for (i = 0; i < 2048; i++)
		c0[i] += x;

	for (i = 0; i < 2048; i++)
	{
		ii = i;
		jj = 0;
		kk = 2048;
		for (j = 1; j < 12; j++)
		{
			kk = kk / 2;
			jj = jj + kk*(ii % 2);
			ii = int(ii / 2);
		}
		j = jj;
		if (j > i)
		{
			t0 = c0[j];
			t1 = c1[j];
			c0[j] = c0[i];
			c1[j] = c1[i];
			c0[i] = t0;
			c1[i] = t1;
		}
	}
	kmax = 1;
	do
	{
		istep = kmax * 2;
		for (k = 0; k < kmax; k++)
		{
			th = -4.0 * atan(1.0) * k / kmax;
			cs = cos(th);
			sn = sin(th);
			for (i = k; i < 2048; i += istep)
			{
				j = i + kmax;
				t0 = c0[j] * cs - c1[j] * sn;
				t1 = c0[j] * sn + c1[j] * cs;
				c0[j] = c0[i] - t0;
				c1[j] = c1[i] - t1;
				c0[i] = c0[i] + t0;
				c1[i] = c1[i] + t1;
			}
		}
		kmax = istep;
	} while (kmax < 2048);

	bufOut[0][0] = 0;
	for (i = 1; i < ONE_BLOCK_DATA_NUM; i++)
	{
		g = c0[i] * c0[i] + c1[i] * c1[i];
		g = sqrt(g);
		bufOut[0][i] = 20 * log10(g);
	}
}
